# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2012 Martijn Atema <martijnatema@gmail.com>
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

import gettext
from gettext import gettext as _
gettext.textdomain('temperature-converter')

from gi.repository import Gtk # pylint: disable=E0611
import logging
logger = logging.getLogger('temperature_converter')

from temperature_converter_lib import Window
from temperature_converter.AboutTemperatureConverterDialog import AboutTemperatureConverterDialog

class TemperatureConverterWindow(Window):
    __gtype_name__ = "TemperatureConverterWindow"
    
    def finish_initializing(self, builder): # pylint: disable=E1002
        """Set up the main window"""
        super(TemperatureConverterWindow, self).finish_initializing(builder)

        self.AboutDialog = AboutTemperatureConverterDialog

    def on_adjustmentCelsius_value_changed(self, widget, data=None):
        celsius = self.ui.adjustmentCelsius.get_value()
        tmp = celsius + 273.15
        self.ui.adjustmentKelvin.set_value(tmp)
        tmp = celsius * 9 / 5 + 32
        self.ui.adjustmentFahrenheit.set_value(tmp)
        tmp = (celsius + 273.15) * 9 / 5
        self.ui.adjustmentRankine.set_value(tmp)
        tmp = celsius * 33 / 100
        self.ui.adjustmentNewton.set_value(tmp)
        tmp = celsius * 4 / 5
        self.ui.adjustmentReaumur.set_value(tmp)
        tmp = celsius * 21 / 40 + 7.5
        self.ui.adjustmentRomer.set_value(tmp)
   
    def on_adjustmentKelvin_value_changed(self, widget, data=None):
        kelvincelsius = self.ui.adjustmentKelvin.get_value() - 273.15
        self.ui.adjustmentCelsius.set_value(kelvincelsius)
        
    def on_adjustmentFahrenheit_value_changed(self, widget, data=None):
        fahrenheitcelsius = (self.ui.adjustmentFahrenheit.get_value() -32) * 5 / 9
        self.ui.adjustmentCelsius.set_value(fahrenheitcelsius)
        
    def on_adjustmentRankine_value_changed(self, widget, data=None):
        rankinecelsius = (self.ui.adjustmentRankine.get_value() - 491.67) * 5 / 9
        self.ui.adjustmentCelsius.set_value(rankinecelsius)
    
    def on_adjustmentNewton_value_changed(self, widget, data=None):
        newtoncelsius = self.ui.adjustmentNewton.get_value() * 100 / 33
        self.ui.adjustmentCelsius.set_value(newtoncelsius)
    
    def on_adjustmentReaumur_value_changed(self, widget, data=None):
        reaumurcelsius = self.ui.adjustmentReaumur.get_value() * 5 / 4
        self.ui.adjustmentCelsius.set_value(reaumurcelsius)
    
    def on_adjustmentRomer_value_changed(self, widget, data=None):
        romercelsius = (self.ui.adjustmentRomer.get_value() - 7.5) * 40 / 21
        self.ui.adjustmentCelsius.set_value(romercelsius)
